/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.200 Revision 1.219
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.200 2005/09/23 20:44:26 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.219 2005/11/29 03:37:36 vapier Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
60# to point to the latest version of the library present. 60# to point to the latest version of the library present.
61# 61#
62# <azarah@gentoo.org> (26 Oct 2002) 62# <azarah@gentoo.org> (26 Oct 2002)
63# 63#
64gen_usr_ldscript() { 64gen_usr_ldscript() {
65 local libdir="$(get_libdir)" 65 local lib libdir=$(get_libdir)
66 # Just make sure it exists 66 # Just make sure it exists
67 dodir /usr/${libdir} 67 dodir /usr/${libdir}
68 68
69 for lib in "${@}" ; do 69 for lib in "${@}" ; do
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
76 76
77 See bug http://bugs.gentoo.org/4411 for more info. 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */ 78 */
79 GROUP ( /${libdir}/${lib} ) 79 GROUP ( /${libdir}/${lib} )
80 END_LDSCRIPT 80 END_LDSCRIPT
81 fperms a+x "/usr/${libdir}/${lib}" 81 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}"
82 done 82 done
83} 83}
84 84
85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
87#
88# <azarah@gentoo.org> (11 Nov 2002)
89#
90draw_line() {
91 local i=0
92 local str_length=""
93
94 # Handle calls that do not have args, or wc not being installed ...
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
96 then
97 echo "==============================================================="
98 return 0
99 fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done
110
111 echo
112
113 return 0
114}
115 85
116# Default directory where patches are located 86# Default directory where patches are located
117EPATCH_SOURCE="${WORKDIR}/patch" 87EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 88# Default extension for patches
119EPATCH_SUFFIX="patch.bz2" 89EPATCH_SUFFIX="patch.bz2"
166# hand its a directory, it will set EPATCH_SOURCE to this. 136# hand its a directory, it will set EPATCH_SOURCE to this.
167# 137#
168# <azarah@gentoo.org> (10 Nov 2002) 138# <azarah@gentoo.org> (10 Nov 2002)
169# 139#
170epatch() { 140epatch() {
141 _epatch_draw_line() {
142 local i=0 str_length="" str_out=""
143
144 # Handle calls that do not have args, or wc not being installed ...
145 if [[ -z $1 ]] || ! type -p wc >/dev/null ; then
146 str_length=65
147 else
148 str_length=$(echo -n "$*" | wc -m)
149 fi
150
151 while ((i++ < ${str_length})) ; do
152 str_out="${str_out}="
153 done
154 echo ${str_out}
155
156 return 0
157 }
158 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
171 local PIPE_CMD="" 159 local PIPE_CMD=""
172 local STDERR_TARGET="${T}/$$.out" 160 local STDERR_TARGET="${T}/$$.out"
173 local PATCH_TARGET="${T}/$$.patch" 161 local PATCH_TARGET="${T}/$$.patch"
174 local PATCH_SUFFIX="" 162 local PATCH_SUFFIX=""
175 local SINGLE_PATCH="no" 163 local SINGLE_PATCH="no"
284 272
285 # Allow for prefix to differ ... im lazy, so shoot me :/ 273 # Allow for prefix to differ ... im lazy, so shoot me :/
286 while [ "${count}" -lt 5 ] 274 while [ "${count}" -lt 5 ]
287 do 275 do
288 # Generate some useful debug info ... 276 # Generate some useful debug info ...
289 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 277 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291 279
292 if [ "${PATCH_SUFFIX}" != "patch" ] 280 if [ "${PATCH_SUFFIX}" != "patch" ]
293 then 281 then
294 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 282 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
299 287
300 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 288 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 289 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302 290
303 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 291 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 292 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305 293
306 if [ "${PATCH_SUFFIX}" != "patch" ] 294 if [ "${PATCH_SUFFIX}" != "patch" ]
307 then 295 then
308 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 296 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
309 then 297 then
313 count=5 301 count=5
314 break 302 break
315 fi 303 fi
316 fi 304 fi
317 305
318 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 306 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
319 then 307 then
320 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 308 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 309 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 310 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 311 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 312 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325 313
326 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 314 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
315 _epatch_assert
327 316
328 if [ "$?" -ne 0 ] 317 if [ "$?" -ne 0 ]
329 then 318 then
330 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 319 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo 320 echo
408# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 397# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
409# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 398# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
410# 399#
411# egetent(database, key) 400# egetent(database, key)
412egetent() { 401egetent() {
413 if [[ "${USERLAND}" == "Darwin" ]] ; then 402 case ${CHOST} in
403 *-darwin*)
414 case "$2" in 404 case "$2" in
415 *[!0-9]*) # Non numeric 405 *[!0-9]*) # Non numeric
416 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 406 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
417 ;; 407 ;;
418 *) # Numeric 408 *) # Numeric
419 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 409 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
420 ;; 410 ;;
421 esac 411 esac
422 elif [[ "${USERLAND}" == "BSD" ]] ; then 412 ;;
423 local action 413 *-freebsd*)
424 if [ "$1" == "passwd" ] 414 local opts action="user"
425 then 415 [[ $1 == "passwd" ]] || action="group"
426 action="user" 416
427 else 417 # lookup by uid/gid
428 action="group" 418 if [[ $2 == [[:digit:]]* ]] ; then
419 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
429 fi 420 fi
421
430 pw show "${action}" "$2" -q 422 pw show ${action} ${opts} "$2" -q
431 else 423 ;;
424 *-netbsd*|*-openbsd*)
425 grep "$2:\*:" /etc/$1
426 ;;
427 *)
432 which nscd >& /dev/null && nscd -i "$1" 428 type -p nscd >& /dev/null && nscd -i "$1"
433 getent "$1" "$2" 429 getent "$1" "$2"
434 fi 430 ;;
431 esac
435} 432}
436 433
437# Simplify/standardize adding users to the system 434# Simplify/standardize adding users to the system
438# vapier@gentoo.org 435# vapier@gentoo.org
439# 436#
492 if [[ ! -e ${eshell} ]] ; then 489 if [[ ! -e ${eshell} ]] ; then
493 eerror "A shell was specified but it does not exist !" 490 eerror "A shell was specified but it does not exist !"
494 die "${eshell} does not exist" 491 die "${eshell} does not exist"
495 fi 492 fi
496 else 493 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null; do 494 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break; 495 [[ -x ${ROOT}${shell} ]] && break
499 done 496 done
500 497
501 if [[ ${shell} == "/dev/null" ]]; then 498 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use" 499 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use" 500 die "Unable to identify the shell to use"
504 fi 501 fi
505 502
506 eshell=${shell} 503 eshell=${shell}
548 einfo " - Groups: ${egroups}" 545 einfo " - Groups: ${egroups}"
549 546
550 # handle extra and add the user 547 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON} 548 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0" 549 export SANDBOX_ON="0"
553 case ${USERLAND} in 550 case ${CHOST} in
554 Darwin) 551 *-darwin*)
555 ### Make the user 552 ### Make the user
556 if [[ -z $@ ]] ; then 553 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid} 554 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell} 555 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome} 556 dscl . create /users/${euser} home ${ehome}
570 einfo "Please report the ebuild along with the info below" 567 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@" 568 einfo "eextra: $@"
572 die "Required function missing" 569 die "Required function missing"
573 fi 570 fi
574 ;; 571 ;;
575 BSD) 572 *-freebsd*)
576 if [[ -z $@ ]] ; then 573 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \ 574 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \ 575 -c "added by portage for ${PN}" \
579 die "enewuser failed" 576 die "enewuser failed"
580 else 577 else
581 einfo " - Extra: $@" 578 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \ 579 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed" 580 "$@" || die "enewuser failed"
584 fi 581 fi
585 ;; 582 ;;
583
584 *-netbsd*)
585 if [[ -z $@ ]] ; then
586 useradd ${opts} ${euser} || die "enewuser failed"
587 else
588 einfo " - Extra: $@"
589 useradd ${opts} ${euser} "$@" || die "enewuser failed"
590 fi
591 ;;
592
593 *-openbsd*)
594 if [[ -z $@ ]] ; then
595 useradd -u ${euid} -s ${eshell} \
596 -d ${ehome} -c "Added by portage for ${PN}" \
597 -g ${egroups} ${euser} || die "enewuser failed"
598 else
599 einfo " - Extra: $@"
600 useradd -u ${euid} -s ${eshell} \
601 -d ${ehome} -c "Added by portage for ${PN}" \
602 -g ${egroups} ${euser} "$@" || die "enewuser failed"
603 fi
604 ;;
605
586 *) 606 *)
587 if [[ -z $@ ]] ; then 607 if [[ -z $@ ]] ; then
588 useradd ${opts} ${euser} \ 608 useradd ${opts} ${euser} \
589 -c "added by portage for ${PN}" \ 609 -c "added by portage for ${PN}" \
590 || die "enewuser failed" 610 || die "enewuser failed"
640 then 660 then
641 if [ "${egid}" -gt 0 ] 661 if [ "${egid}" -gt 0 ]
642 then 662 then
643 if [ -z "`egetent group ${egid}`" ] 663 if [ -z "`egetent group ${egid}`" ]
644 then 664 then
645 if [[ "${USERLAND}" == "Darwin" ]]; then 665 if [[ "${CHOST}" == *-darwin* ]]; then
646 opts="${opts} ${egid}" 666 opts="${opts} ${egid}"
647 else 667 else
648 opts="${opts} -g ${egid}" 668 opts="${opts} -g ${egid}"
649 fi 669 fi
650 else 670 else
664 opts="${opts} ${eextra}" 684 opts="${opts} ${eextra}"
665 685
666 # add the group 686 # add the group
667 local oldsandbox="${SANDBOX_ON}" 687 local oldsandbox="${SANDBOX_ON}"
668 export SANDBOX_ON="0" 688 export SANDBOX_ON="0"
669 if [[ "${USERLAND}" == "Darwin" ]]; then 689 case ${CHOST} in
690 *-darwin*)
670 if [ ! -z "${eextra}" ]; 691 if [ ! -z "${eextra}" ];
671 then 692 then
672 einfo "Extra options are not supported on Darwin/OS X yet" 693 einfo "Extra options are not supported on Darwin/OS X yet"
673 einfo "Please report the ebuild along with the info below" 694 einfo "Please report the ebuild along with the info below"
674 einfo "eextra: ${eextra}" 695 einfo "eextra: ${eextra}"
675 die "Required function missing" 696 die "Required function missing"
676 fi 697 fi
677 698
678 # If we need the next available 699 # If we need the next available
679 case ${egid} in 700 case ${egid} in
680 *[!0-9]*) # Non numeric 701 *[!0-9]*) # Non numeric
681 for egid in $(seq 101 999); do 702 for egid in $(seq 101 999); do
682 [ -z "`egetent group ${egid}`" ] && break 703 [ -z "`egetent group ${egid}`" ] && break
683 done 704 done
684 esac 705 esac
685 dscl . create /groups/${egroup} gid ${egid} 706 dscl . create /groups/${egroup} gid ${egid}
686 dscl . create /groups/${egroup} passwd '*' 707 dscl . create /groups/${egroup} passwd '*'
687 elif [[ "${USERLAND}" == "BSD" ]] ; then 708 ;;
709
710 *-freebsd*)
688 case ${egid} in 711 case ${egid} in
689 *[!0-9]*) # Non numeric 712 *[!0-9]*) # Non numeric
690 for egid in $(seq 101 999); do 713 for egid in $(seq 101 999); do
691 [ -z "`egetent group ${egid}`" ] && break 714 [ -z "`egetent group ${egid}`" ] && break
692 done 715 done
693 esac 716 esac
694 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 717 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
695 else 718 ;;
719
720 *-netbsd*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
728 ;;
729
730 *)
696 groupadd ${opts} ${egroup} || die "enewgroup failed" 731 groupadd ${opts} ${egroup} || die "enewgroup failed"
697 fi 732 ;;
733 esac
698 export SANDBOX_ON="${oldsandbox}" 734 export SANDBOX_ON="${oldsandbox}"
699} 735}
700 736
701# Simple script to replace 'dos2unix' binaries 737# Simple script to replace 'dos2unix' binaries
702# vapier@gentoo.org 738# vapier@gentoo.org
813 type="Network;${type}" 849 type="Network;${type}"
814 ;; 850 ;;
815 851
816 sci) 852 sci)
817 case ${catmin} in 853 case ${catmin} in
818 astro*) type=Astronomoy;; 854 astro*) type=Astronomy;;
819 bio*) type=Biology;; 855 bio*) type=Biology;;
820 calc*) type=Calculator;; 856 calc*) type=Calculator;;
821 chem*) type=Chemistry;; 857 chem*) type=Chemistry;;
822 geo*) type=Geology;; 858 geo*) type=Geology;;
823 math*) type=Math;; 859 math*) type=Math;;
855Exec=${exec} 891Exec=${exec}
856Path=${path} 892Path=${path}
857Icon=${icon} 893Icon=${icon}
858Categories=Application;${type};" > "${desktop}" 894Categories=Application;${type};" > "${desktop}"
859 895
896 (
897 # wrap the env here so that the 'insinto' call
898 # doesn't corrupt the env of the caller
860 insinto /usr/share/applications 899 insinto /usr/share/applications
861 doins "${desktop}" 900 doins "${desktop}"
862 901 )
863 return 0
864} 902}
865 903
866# Make a GDM/KDM Session file 904# Make a GDM/KDM Session file
867# 905#
868# make_desktop_entry(<title>, <command>) 906# make_desktop_entry(<title>, <command>)
973 local sizeoff_t=$2 1011 local sizeoff_t=$2
974 1012
975 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1013 [[ -z ${src} ]] && die "Could not locate source for '$1'"
976 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1014 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
977 1015
978 local shrtsrc="`basename ${src}`" 1016 local shrtsrc=$(basename "${src}")
979 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1017 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
980 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1018 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
981 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1019 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
982 1020
983 # grab metadata for debug reasons 1021 # grab metadata for debug reasons
1047# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1085# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1048# - If the file is not specified then unpack will utilize ${A}. 1086# - If the file is not specified then unpack will utilize ${A}.
1049# - If the offset is not specified then we will attempt to extract 1087# - If the offset is not specified then we will attempt to extract
1050# the proper offset from the script itself. 1088# the proper offset from the script itself.
1051unpack_makeself() { 1089unpack_makeself() {
1090 local src_input=${1:-${A}}
1052 local src=$(find_unpackable_file "$1") 1091 local src=$(find_unpackable_file "${src_input}")
1053 local skip=$2 1092 local skip=$2
1054 local exe=$3 1093 local exe=$3
1055 1094
1056 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1095 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1057 1096
1058 local shrtsrc=$(basename "${src}") 1097 local shrtsrc=$(basename "${src}")
1059 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1098 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1060 if [ -z "${skip}" ] 1099 if [[ -z ${skip} ]] ; then
1061 then
1062 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1100 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1063 local skip=0 1101 local skip=0
1064 exe=tail 1102 exe=tail
1065 case ${ver} in 1103 case ${ver} in
1066 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1104 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1067 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1105 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1079 ;; 1117 ;;
1080 2.1.3) 1118 2.1.3)
1081 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1119 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1082 let skip="skip + 1" 1120 let skip="skip + 1"
1083 ;; 1121 ;;
1084 2.1.4) 1122 2.1.4|2.1.5)
1085 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1123 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1086 skip=$(head -n ${skip} "${src}" | wc -c) 1124 skip=$(head -n ${skip} "${src}" | wc -c)
1087 exe="dd" 1125 exe="dd"
1088 ;; 1126 ;;
1089 *) 1127 *)
1208 # first we figure out how many cds we're dealing with by 1246 # first we figure out how many cds we're dealing with by
1209 # the # of files they gave us 1247 # the # of files they gave us
1210 local cdcnt=0 1248 local cdcnt=0
1211 local f= 1249 local f=
1212 for f in "$@" ; do 1250 for f in "$@" ; do
1213 cdcnt=$((cdcnt + 1)) 1251 ((++cdcnt))
1214 export CDROM_CHECK_${cdcnt}="$f" 1252 export CDROM_CHECK_${cdcnt}="$f"
1215 done 1253 done
1216 export CDROM_TOTAL_CDS=${cdcnt} 1254 export CDROM_TOTAL_CDS=${cdcnt}
1217 export CDROM_CURRENT_CD=1 1255 export CDROM_CURRENT_CD=1
1218 1256
1219 # now we see if the user gave use CD_ROOT ... 1257 # now we see if the user gave use CD_ROOT ...
1220 # if they did, let's just believe them that it's correct 1258 # if they did, let's just believe them that it's correct
1221 if [[ ! -z ${CD_ROOT} ]] ; then
1222 export CDROM_ROOT=${CD_ROOT}
1223 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1224 return
1225 fi
1226 # do the same for CD_ROOT_X
1227 if [[ ! -z ${CD_ROOT_1} ]] ; then 1259 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1228 local var= 1260 local var=
1229 cdcnt=0 1261 cdcnt=0
1230 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1262 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1231 cdcnt=$((cdcnt + 1)) 1263 ((++cdcnt))
1232 var="CD_ROOT_${cdcnt}" 1264 var="CD_ROOT_${cdcnt}"
1265 [[ -z ${!var} ]] && var="CD_ROOT"
1233 if [[ -z ${!var} ]] ; then 1266 if [[ -z ${!var} ]] ; then
1234 eerror "You must either use just the CD_ROOT" 1267 eerror "You must either use just the CD_ROOT"
1235 eerror "or specify ALL the CD_ROOT_X variables." 1268 eerror "or specify ALL the CD_ROOT_X variables."
1236 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1269 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1237 die "could not locate CD_ROOT_${cdcnt}" 1270 die "could not locate CD_ROOT_${cdcnt}"
1238 fi 1271 fi
1239 export CDROM_ROOTS_${cdcnt}="${!var}"
1240 done 1272 done
1241 export CDROM_ROOT=${CDROM_ROOTS_1} 1273 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1242 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1274 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1275 export CDROM_SET=-1
1276 for f in ${CDROM_CHECK_1//:/ } ; do
1277 ((++CDROM_SET))
1278 [[ -e ${CD_ROOT}/${f} ]] && break
1279 done
1280 export CDROM_MATCH=${f}
1243 return 1281 return
1244 fi 1282 fi
1245 1283
1284 # User didn't help us out so lets make sure they know they can
1285 # simplify the whole process ...
1246 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1286 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1247 einfon "This ebuild will need the " 1287 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1248 if [[ -z ${CDROM_NAME} ]] ; then
1249 echo "cdrom for ${PN}."
1250 else
1251 echo "${CDROM_NAME}."
1252 fi
1253 echo 1288 echo
1254 einfo "If you do not have the CD, but have the data files" 1289 einfo "If you do not have the CD, but have the data files"
1255 einfo "mounted somewhere on your filesystem, just export" 1290 einfo "mounted somewhere on your filesystem, just export"
1256 einfo "the variable CD_ROOT so that it points to the" 1291 einfo "the variable CD_ROOT so that it points to the"
1257 einfo "directory containing the files." 1292 einfo "directory containing the files."
1261 echo 1296 echo
1262 else 1297 else
1263 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1298 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1264 cdcnt=0 1299 cdcnt=0
1265 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1300 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1266 cdcnt=$((cdcnt + 1)) 1301 ((++cdcnt))
1267 var="CDROM_NAME_${cdcnt}" 1302 var="CDROM_NAME_${cdcnt}"
1268 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1303 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1269 done 1304 done
1270 echo 1305 echo
1271 einfo "If you do not have the CDs, but have the data files" 1306 einfo "If you do not have the CDs, but have the data files"
1272 einfo "mounted somewhere on your filesystem, just export" 1307 einfo "mounted somewhere on your filesystem, just export"
1273 einfo "the following variables so they point to the right place:" 1308 einfo "the following variables so they point to the right place:"
1274 einfon "" 1309 einfon ""
1275 cdcnt=0 1310 cdcnt=0
1276 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1311 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1277 cdcnt=$((cdcnt + 1)) 1312 ((++cdcnt))
1278 echo -n " CD_ROOT_${cdcnt}" 1313 echo -n " CD_ROOT_${cdcnt}"
1279 done 1314 done
1280 echo 1315 echo
1281 einfo "Or, if you have all the files in the same place, or" 1316 einfo "Or, if you have all the files in the same place, or"
1282 einfo "you only have one cdrom, you can export CD_ROOT" 1317 einfo "you only have one cdrom, you can export CD_ROOT"
1285 echo 1320 echo
1286 einfo "For example:" 1321 einfo "For example:"
1287 einfo "export CD_ROOT_1=/mnt/cdrom" 1322 einfo "export CD_ROOT_1=/mnt/cdrom"
1288 echo 1323 echo
1289 fi 1324 fi
1325
1326 export CDROM_SET=""
1290 export CDROM_CURRENT_CD=0 1327 export CDROM_CURRENT_CD=0
1291 cdrom_load_next_cd 1328 cdrom_load_next_cd
1292} 1329}
1293 1330
1294# this is only used when you need access to more than one cd. 1331# this is only used when you need access to more than one cd.
1295# when you have finished using the first cd, just call this function. 1332# when you have finished using the first cd, just call this function.
1296# when it returns, CDROM_ROOT will be pointing to the second cd. 1333# when it returns, CDROM_ROOT will be pointing to the second cd.
1297# remember, you can only go forward in the cd chain, you can't go back. 1334# remember, you can only go forward in the cd chain, you can't go back.
1298cdrom_load_next_cd() { 1335cdrom_load_next_cd() {
1299 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1300 local var= 1336 local var
1301 1337 ((++CDROM_CURRENT_CD))
1302 if [[ ! -z ${CD_ROOT} ]] ; then
1303 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1304 return
1305 fi
1306 1338
1307 unset CDROM_ROOT 1339 unset CDROM_ROOT
1308 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1340 var=CD_ROOT_${CDROM_CURRENT_CD}
1341 [[ -z ${!var} ]] && var="CD_ROOT"
1309 if [[ -z ${!var} ]] ; then 1342 if [[ -z ${!var} ]] ; then
1310 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1343 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1311 cdrom_locate_file_on_cd ${!var} 1344 _cdrom_locate_file_on_cd ${!var}
1312 else 1345 else
1313 export CDROM_ROOT=${!var} 1346 export CDROM_ROOT=${!var}
1314 fi 1347 fi
1315 1348
1316 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1349 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1321# all it does is try to locate a give file on a cd ... if the cd isn't 1354# all it does is try to locate a give file on a cd ... if the cd isn't
1322# found, then a message asking for the user to insert the cdrom will be 1355# found, then a message asking for the user to insert the cdrom will be
1323# displayed and we'll hang out here until: 1356# displayed and we'll hang out here until:
1324# (1) the file is found on a mounted cdrom 1357# (1) the file is found on a mounted cdrom
1325# (2) the user hits CTRL+C 1358# (2) the user hits CTRL+C
1326cdrom_locate_file_on_cd() { 1359_cdrom_locate_file_on_cd() {
1360 local mline=""
1361 local showedmsg=0
1362
1327 while [[ -z ${CDROM_ROOT} ]] ; do 1363 while [[ -z ${CDROM_ROOT} ]] ; do
1328 local dir=$(dirname "$*") 1364 local i=0
1365 local -a cdset=(${*//:/ })
1366 if [[ -n ${CDROM_SET} ]] ; then
1367 cdset=(${cdset[${CDROM_SET}]})
1368 fi
1369
1370 while [[ -n ${cdset[${i}]} ]] ; do
1371 local dir=$(dirname ${cdset[${i}]})
1329 local file=$(basename "$*") 1372 local file=$(basename ${cdset[${i}]})
1330 local mline=""
1331 local showedmsg=0
1332 1373
1333 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1374 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1334 [[ -d ${mline}/${dir} ]] || continue 1375 [[ -d ${mline}/${dir} ]] || continue
1335 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \ 1376 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1336 && export CDROM_ROOT=${mline} 1377 export CDROM_ROOT=${mline}
1378 export CDROM_SET=${i}
1379 export CDROM_MATCH=${cdset[${i}]}
1380 return
1381 fi
1382 done
1383
1384 ((++i))
1337 done 1385 done
1338 1386
1339 if [[ -z ${CDROM_ROOT} ]] ; then
1340 echo 1387 echo
1341 if [[ ${showedmsg} -eq 0 ]] ; then 1388 if [[ ${showedmsg} -eq 0 ]] ; then
1342 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1389 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1343 if [[ -z ${CDROM_NAME} ]] ; then 1390 if [[ -z ${CDROM_NAME} ]] ; then
1344 einfo "Please insert the cdrom for ${PN} now !" 1391 einfo "Please insert+mount the cdrom for ${PN} now !"
1345 else
1346 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1347 fi
1348 else 1392 else
1349 if [[ -z ${CDROM_NAME_1} ]] ; then
1350 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1351 else
1352 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1353 einfo "Please insert+mount the ${!var} cdrom now !" 1393 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1354 fi
1355 fi 1394 fi
1356 showedmsg=1 1395 else
1396 if [[ -z ${CDROM_NAME_1} ]] ; then
1397 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1398 else
1399 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1400 einfo "Please insert+mount the ${!var} cdrom now !"
1401 fi
1357 fi 1402 fi
1403 showedmsg=1
1404 fi
1358 einfo "Press return to scan for the cd again" 1405 einfo "Press return to scan for the cd again"
1359 einfo "or hit CTRL+C to abort the emerge." 1406 einfo "or hit CTRL+C to abort the emerge."
1360 echo 1407 echo
1361 einfo "If you are having trouble with the detection" 1408 einfo "If you are having trouble with the detection"
1362 einfo "of your CD, it is possible that you do not have" 1409 einfo "of your CD, it is possible that you do not have"
1363 einfo "Joliet support enabled in your kernel. Please" 1410 einfo "Joliet support enabled in your kernel. Please"
1364 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1411 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1365 read 1412 read
1366 fi
1367 done 1413 done
1368} 1414}
1369 1415
1370# Make sure that LINGUAS only contains languages that 1416# Make sure that LINGUAS only contains languages that
1371# a package can support 1417# a package can support
1519 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1565 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1520 1566
1521 local PKG=$(best_version $1) 1567 local PKG=$(best_version $1)
1522 shift 1568 shift
1523 1569
1524 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1570 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1571
1572 # if the USE file doesnt exist, assume the $PKG is either
1573 # injected or package.provided
1525 [[ ! -e ${USEFILE} ]] && return 1 1574 [[ ! -e ${USEFILE} ]] && return 0
1526 1575
1527 local USE_BUILT=$(<${USEFILE}) 1576 local USE_BUILT=$(<${USEFILE})
1528 while [[ $# -gt 0 ]] ; do 1577 while [[ $# -gt 0 ]] ; do
1529 if [[ ${opt} = "-o" ]] ; then 1578 if [[ ${opt} = "-o" ]] ; then
1530 has $1 ${USE_BUILT} && return 0 1579 has $1 ${USE_BUILT} && return 0
1582# $4 == extra LD_LIBRARY_PATH's (make it : delimited) 1631# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1583# $5 == path for wrapper 1632# $5 == path for wrapper
1584make_wrapper() { 1633make_wrapper() {
1585 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1634 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1586 local tmpwrapper=$(emktemp) 1635 local tmpwrapper=$(emktemp)
1636 # We don't want to quote ${bin} so that people can pass complex
1637 # things as $bin ... "./someprog --args"
1587 cat << EOF > "${tmpwrapper}" 1638 cat << EOF > "${tmpwrapper}"
1588#!/bin/sh 1639#!/bin/sh
1589cd "${chdir}" 1640cd "${chdir:-.}"
1641if [ -n "${libdir}" ] ; then
1642 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1590export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}" 1643 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1644 else
1645 export LD_LIBRARY_PATH="${libdir}"
1646 fi
1647fi
1591exec ${bin} "\$@" 1648exec ${bin} "\$@"
1592EOF 1649EOF
1593 chmod go+rx "${tmpwrapper}" 1650 chmod go+rx "${tmpwrapper}"
1594 if [ -n "${5}" ] 1651 if [[ -n ${path} ]] ; then
1595 then
1596 exeinto ${5} 1652 exeinto "${path}"
1597 newexe "${tmpwrapper}" "${wrapper}" 1653 newexe "${tmpwrapper}" "${wrapper}"
1598 else 1654 else
1599 newbin "${tmpwrapper}" "${wrapper}" 1655 newbin "${tmpwrapper}" "${wrapper}"
1600 fi 1656 fi
1601} 1657}

Legend:
Removed from v.1.200  
changed lines
  Added in v.1.219

  ViewVC Help
Powered by ViewVC 1.1.20